// MindScope.cpp :  Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MindScope.h"
#include "MindScopeDlg.h"
#include "gdiplus.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	IPADDRKEY			"AIBO-IP"
#define	DEFAULT_AIBOIP		"10.0.1.100"
#define APPLICATION_NAME	"VirtualAIBO\\RemoteTest"
#define MASTER_REGISTRY_KEY	"Sony"

/////////////////////////////////////////////////////////////////////////////
// CMindScopeApp

BEGIN_MESSAGE_MAP(CMindScopeApp, CWinApp)
	//{{AFX_MSG_MAP(CMindScopeApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMindScopeApp construction

CMindScopeApp::CMindScopeApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMindScopeApp object

CMindScopeApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMindScopeApp Initialization

BOOL CMindScopeApp::InitInstance()
{

	// Standard initialization

	// Initialize GDI+
    using namespace Gdiplus;
    GdiplusStartupInput gdiplusStartupInput;
    GdiplusStartup( &m_gdiplusToken, &gdiplusStartupInput, NULL );

#ifdef _AFXDLL
	Enable3dControls();
#else
	Enable3dControlsStatic();
#endif
	// Reset Application name
	free((void*)m_pszAppName);
	m_pszAppName=_tcsdup(_T(APPLICATION_NAME));

	// Get AIBO's IP from the registry key
	SetRegistryKey(_T(MASTER_REGISTRY_KEY));
	m_sAiboIP = GetProfileString("", IPADDRKEY, DEFAULT_AIBOIP);
	WriteProfileString("", IPADDRKEY, m_sAiboIP);

	CMindScopeDlg dlg;
	m_pMainWnd = &dlg;

	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		WriteProfileString("", IPADDRKEY, m_sAiboIP);
	}
	else if (nResponse == IDCANCEL)
	{
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

int CMindScopeApp::ExitInstance()
{

    Gdiplus::GdiplusShutdown( m_gdiplusToken );
	return CWinApp::ExitInstance();
}
