// MindScopeDlg.cpp : Implementation file
//

#include "stdafx.h"
#include "MindScope.h"
#include "MindScopeDlg.h"
#include "VAIBODef.h"
#include "Cpcinfo.h"
#include "ijl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMindScopeDlg dialog

CMindScopeDlg::CMindScopeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMindScopeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMindScopeDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_pVAibo = NULL;
    m_nAiboID = -1;
    m_bConnected = FALSE;
    m_bControl = FALSE;
	m_myRequest = FALSE;

	m_imageBufN = NULL;
	m_bBlockDataEnable = FALSE;
	m_bPointDataEnable = FALSE;
	m_bPoint2DataEnable = FALSE;
	m_bPoint4DataEnable = FALSE;

	m_point_1 = Point(-1,-1); 
	m_point_2[0] = Point(-1,-1);
	m_point_2[1] = Point(-1,-1);
	m_point_4[0] = Point(-1,-1);
	m_point_4[1] = Point(-1,-1);
	m_point_4[2] = Point(-1,-1);
	m_point_4[3] = Point(-1,-1);

	m_point_4_count =0;

}

void CMindScopeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMindScopeDlg)
	DDX_Control(pDX, IDC_IPADDERSS1, m_ipAddress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMindScopeDlg, CDialog)
	//{{AFX_MSG_MAP(CMindScopeDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_BN_CLICKED(IDC_BTN_AUTONOMY, OnBtnAutonomy)
    ON_BN_CLICKED(IDC_BTN_CONNECT, OnBtnConnect)
    ON_BN_CLICKED(IDC_BTN_REMOTE, OnBtnRemote)
    ON_WM_DESTROY()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_REGISTERED_MESSAGE(WM_VAIBO_CONNECT, OnVAIBOConnect)
    ON_REGISTERED_MESSAGE(WM_VAIBO_CLIENT_UPDATE, OnVAIBOConnectUpdate)
    ON_REGISTERED_MESSAGE(WM_VAIBO_DISCONNECT, OnVAIBODisconnect)
    ON_REGISTERED_MESSAGE(WM_VAIBO_SEMANTICS, OnVAIBOSemantics)
    ON_REGISTERED_MESSAGE(WM_VAIBO_REMOTE_NOTIFY, OnVAIBORemoteNotify)
	ON_REGISTERED_MESSAGE(WM_VAIBO_INPUT_SEMANTICS, OnVAIBOInputSemantics)
    ON_REGISTERED_MESSAGE(WM_IMAGETP_UPDATE, OnITPImageUpdate)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMindScopeDlg message handlers

BOOL CMindScopeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
	
    // TODO: Add extra initialization here
    if ( m_pVAibo == NULL ) {
        m_pVAibo = new CVAIBO( this->m_hWnd );
    }
	INT nField0, nField1, nField2, nField3;
    LPCTSTR p = theApp.m_sAiboIP.GetBuffer(128);
    ::sscanf( p, "%d.%d.%d.%d", &nField0, &nField1, &nField2, &nField3 );
    theApp.m_sAiboIP.ReleaseBuffer();
    m_ipAddress.SetAddress( nField0, nField1, nField2, nField3 );

	CString strIP;
	strIP.Format( "%d.%d.%d.%d", nField0, nField1, nField2, nField3 );
		
	return TRUE;   // return TRUE  unless you set the focus to a control
}

void CMindScopeDlg::OnPaint() 
{
	if (IsIconic())
	{
        CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        // Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

		if(m_imageBufN != NULL) {
			CWnd	*wnd = GetDlgItem( IDC_IMAGE );
			CPaintDC dc(wnd);
			CRect rc;
			wnd->GetClientRect(&rc);

			// Create double buffer
			CDC dc1;
			dc1.CreateCompatibleDC(&dc);
			CBitmap bmp;
			bmp.CreateCompatibleBitmap( &dc, rc.Width(),rc.Height() );
			dc1.SelectObject(&bmp);

			// Draw camera image to the buffer
			unsigned char   *image;
			int             y = 0;
			image = m_imageBufN + sizeof(BITMAPINFO);
			int len = ( m_bmpLen - sizeof(BITMAPINFO ) ) * 3;

			::SetStretchBltMode(dc1.m_hDC, HALFTONE);
			::StretchDIBits(dc1.m_hDC,
				rc.left,rc.top,rc.Width(),rc.Height(),  
				0,0,
				m_bitmapWidth,
				m_bitmapHeight,
				image,(BITMAPINFO*)m_imageBufN,DIB_RGB_COLORS,SRCCOPY);

			// Draw moving object grids
			Graphics graphics(dc1.m_hDC);
			graphics.SetSmoothingMode( SmoothingModeHighQuality );

			if(m_bBlockDataEnable) {
				float nBlockX = (float)rc.Width()/(float)m_blockInfo.nBlock_X;
				float nBlockY = (float)rc.Height()/(float)m_blockInfo.nBlock_Y;
				int blockSize = m_blockInfo.nBlock_X*m_blockInfo.nBlock_Y/8;

				Rect rect;
				Pen bluepen( Color(150, 100, 100, 255), 1);

				int x=0, y=0;
				for(int ind=0;ind<blockSize;ind++){
					unsigned char ii = *(m_pBlockData+ind);
					for(int i=0;i<8;i++){
						rect.X   = (int)(x * nBlockX + rc.left);
						rect.Width  = (int)nBlockX;
						rect.Y    = (int)(y * nBlockY + rc.top);
						rect.Height = (int)nBlockY;
			
						if ( ii & 0x80 ) {
							graphics.DrawRectangle(&bluepen, rect);		
						}
			
						x++;
						if( x >= m_blockInfo.nBlock_X ) {
							x=0;
							y++;
						}
						ii = ii  << 1;
					}
				}
			}

			// Image size table
			struct ImageSize {
				int		type;
				float	xsize;
				float	ysize;
			};

			// Set the table values (Image type to Image size)
			static ImageSize ImageSizeTable[3] = {
				{ PFT_LOW,	102,	79}, // See VAIBOImageRecognition.h
				{ PFT_MID,	204,	159},
				{ PFT_HIGH,	412,	318}
			};

			// Draw 1 point (BALL/BONE/PINK)
			if(m_bPointDataEnable) {

				float xsize, ysize;
				for( int i=0; i<3; i++ ) {
					if( m_recogHeader1.imageType == ImageSizeTable[i].type ) {
						xsize = ImageSizeTable[i].xsize;
						ysize = ImageSizeTable[i].ysize;
					}
				}

				float scx = rc.Width() / xsize;
				float scy = rc.Height() / ysize;

				Pen pen1( Color(150, 0, 255, 0), 1);
				switch(m_recogHeader1.recogType) {
				case RT_BALL :
					break;
				case RT_BONE :
					pen1.SetColor( Color(150, 255, 255, 0) );
					break;
				case RT_PINK :
					pen1.SetColor( Color(50, 0, 255, 255) );
					break;
				}
				graphics.DrawLine(&pen1,
					0,
					(int)(m_point_1.Y*scy),
					rc.Width(),
					(int)(m_point_1.Y*scy)
					);
				graphics.DrawLine(&pen1,
					(int)(m_point_1.X*scx),
					0,
					(int)(m_point_1.X*scx),
					rc.Height()
					);

			}

            // Draw 2 points (FACE)
			if(m_bPoint2DataEnable) {

				float xsize, ysize;
				for( int i=0; i<3; i++ ) {
					if( m_recogHeader2.imageType == ImageSizeTable[i].type ) {
						xsize = ImageSizeTable[i].xsize;
						ysize = ImageSizeTable[i].ysize;
					}
				}

				float scx = rc.Width() / xsize;
				float scy = rc.Height() / ysize;

				Rect rect(
				    (int)(m_point_2[0].X * scx), 
				    (int)(m_point_2[0].Y * scy),
					(int)((m_point_2[1].X - m_point_2[0].X) * scx),
					(int)((m_point_2[1].Y - m_point_2[0].Y) * scy)
					);

				Pen whitegreenpen( Color(255, 0, 255, 0), 1);
				whitegreenpen.SetDashStyle( DashStyleDash );

				if(m_recogHeader2.subinfo == RTSUB_SKIN ) { 
					// Tracking skin color
					whitegreenpen.SetColor( Color(150, 255, 255, 255) );
				}

				graphics.DrawRectangle(&whitegreenpen, rect);

			}

			// Draw 4 points (VPR)
			if(m_bPoint4DataEnable) {

				// Set VPR lable string
				BSTR vprstring;
				CString tmp;
				switch(m_recogHeader4.recogType) {
					case RT_EPOLE :
						vprstring = L"Station Pole";
						break;
					case RT_ESMARKER :
						vprstring = L"Station Marker";
						break;
					case RT_ECARD1:
						tmp.Format("AIBO Card %d",(0xffff0000 & m_recogHeader4.subinfo)>>16);
						vprstring = tmp.AllocSysString();
						break;
					case RT_ESCENE1:
						vprstring = L"Favorite Place";
						break;
					case RT_ESCENE2:
						vprstring = L"Favorite Place 2";
						break;
					case RT_ESCENE3:
						vprstring = L"Favorite Place 3";
						break;
					case RT_EPTN:
					{
						int num = ((0xffff0000 & m_recogHeader4.subinfo) >>16 ); 
						if( num < 0xff ) {
							tmp.Format("Pattern %d",num +1);
						} else {
							tmp.Format("Favorite thing %d", num - 0xff);
						}
						vprstring = tmp.AllocSysString();
						break;
					}
					default:
						TRACE("VPR UnKnown Type: %02X\n",m_recogHeader4.recogType);
						vprstring = L"UnKnown";
				}

				float xsize, ysize;
				for( int i=0; i<3; i++ ) {
					if( m_recogHeader4.imageType == ImageSizeTable[i].type ) {
						xsize = ImageSizeTable[i].xsize;
						ysize = ImageSizeTable[i].ysize;
					}
				}

				float scx = rc.Width() / xsize;
				float scy = rc.Height() / ysize;
		
				PointF point4[4];
				PointF center;

				for(int j=0; j<4; j++) {
					point4[j].X = (int)m_point_4[j].X * scx; 
					point4[j].Y = (int)m_point_4[j].Y * scy; 
					center.X += (int)m_point_4[j].X * scx;
					center.Y += (int)m_point_4[j].Y * scy;
				}

				// Calculate center coordinates
				center.X /= 4;
				center.Y /= 4;

				// Create Polygon from 4 points
				GraphicsPath path4;
				path4.AddPolygon(point4,4);

				// Draw VPR Polygon
				Pen vprpen( Color( 50 * m_point_4_count, 255, 150, 0), 2);
				graphics.DrawPath(&vprpen, &path4);

				Font fontArial( L"Arial", 14);
				PointF orign(0,0);
				RectF recttmp;
				graphics.MeasureString(vprstring, -1, &fontArial, orign, &recttmp);

				PointF vprxy;
				vprxy.X = center.X - recttmp.Width/2;
				vprxy.Y = center.Y - recttmp.Height/2;

				// Draw VPR Label
				SolidBrush vprb( Color( 255, 255, 255, 0 ));
				graphics.DrawString( vprstring, -1, &fontArial, vprxy, &vprb );
			}
			// Show double buffer image
			dc.BitBlt(0, 0, rc.Width(), rc.Height(), &dc1, 0, 0, SRCCOPY);
		}
	}
}

HCURSOR CMindScopeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
//  ON_REGISTERED_MESSAGE(WM_VAIBO_CLIENT_UPDATE, OnVAIBOConnectUpdate)
//  Another application has already connected to AIBO
LRESULT CMindScopeDlg::OnVAIBOConnectUpdate( WPARAM wParam, LPARAM lParam )
{
    LRESULT result;

    if ((unsigned) m_nAiboID != HIWORD(wParam)) {
        // This is not my AIBO that I requested to connect to
        return S_FALSE;
    }
    if (!m_myRequest) {
        // This is not my request, another application changes the connection status.
        return S_FALSE;
    }
    m_myRequest = FALSE;

	if (LOWORD(wParam) == 1) {
        result = OnVAIBOConnect(wParam, lParam );
    } else {
        result = OnVAIBODisconnect(wParam, lParam );
    }
    return result;
}

//  ON_REGISTERED_MESSAGE(WM_VAIBO_CONNECT, OnVAIBOConnect)
LRESULT CMindScopeDlg::OnVAIBOConnect( WPARAM wParam, LPARAM lParam )
{
    if ((unsigned) m_nAiboID != HIWORD(wParam)) {
        // This is not my AIBO that I requested to connect to
        return S_FALSE;
    }
    buttonConnect().SetWindowText( "Disconnect" );
    m_bConnected = TRUE;
    m_bControl = FALSE;
    buttonRemote().EnableWindow(TRUE);
    buttonAutonomy().EnableWindow(FALSE);

	// Check another application getting remote control
    if ( m_pVAibo->IsRemote() ) {
        OnVAIBORemoteNotify(wParam, 1);
    }

	if ( m_pVAibo->GetStateImageTP() == IMAGETP_STATE_CLOSE ) {
        if ( m_pVAibo->ImageInit() != IMAGETP_STATE_ERR ){
            if ( m_pVAibo->ImageOpen() != IMAGETP_STATE_ERR ){
                if ( m_pVAibo->RequestNetService( IMAGE_ID ) != IMAGETP_STATE_ERR ){
				}
            }
        }
    }

	return S_OK;
}

//  ON_REGISTERED_MESSAGE(WM_VAIBO_DISCONNECT, OnVAIBODisconnect)
LRESULT CMindScopeDlg::OnVAIBODisconnect( WPARAM wParam, LPARAM lParam )
{
    if ((unsigned) m_nAiboID != HIWORD(wParam)) {
        // This is not my AIBO that I was connected to
        return S_FALSE;
    }
    buttonConnect().SetWindowText( "Connect" );
    m_bConnected = FALSE;
    m_bControl = FALSE;
    m_nAiboID = -1;

	if ( m_imageBufN != NULL ) {
        free( m_imageBufN );
		m_imageBufN = NULL;
    }

    buttonRemote().EnableWindow(FALSE);
    buttonAutonomy().EnableWindow(FALSE);

	Invalidate();

    return S_OK;
}
// ON_REGISTERED_MESSAGE(WM_VAIBO_SEMANTICS, OnVAIBOSemantics)
LRESULT CMindScopeDlg::OnVAIBOSemantics( WPARAM wParam, LPARAM lParam )
{
    if ((unsigned) m_nAiboID != HIWORD(wParam)) {
        // This semantics data didn't come from my AIBO
        return S_FALSE;
    }

    if (SEM_RESULT == LOWORD(wParam)) {
	} else if ( SEM_DONE == LOWORD(wParam) ) {
		CString msg;
        switch ( LOWORD( lParam ) ) {
        case DONE_SEND_CMD :
            msg = "Command execute finished\r\n";
            break;

        case DONE_CHANGE_HEAD :
            msg = "ChangeHeadAngle() finished\r\n";
            break;

        case DONE_SET_POSTURE :
            msg = "SetPosture() finished\r\n";
            break;

        case DONE_PLAY_MOTION :
            msg = "PlayMotion() finished\r\n";
            break;

        case DONE_NETAUDIO :
            if ( lParam == RESULT_COMPLETE ) {
                msg = "NetAudio() start\r\n";
            }
            else {
                msg = "NetAudio() finished\r\n";
            }

            break;
		case DONE_WALKING :
			break;
        default:
			msg = "UNKNOWN\n";
            break;
        }
		TRACE(msg);
	 } else if (SEM_START == LOWORD(wParam)) {
		switch (lParam) {
		case START_IMAGETP :
			m_pVAibo->SendCmd( APPCMD_IMAGE_PLAY );
			break;
		}
	}
    return S_OK;
}

LRESULT CMindScopeDlg::OnVAIBOInputSemantics( WPARAM msg, LPARAM data )
{
    return S_OK;
}

//  ON_REGISTERED_MESSAGE(WM_VAIBO_REMOTE_NOTIFY, OnVAIBORemoteNotify)
LRESULT CMindScopeDlg::OnVAIBORemoteNotify( WPARAM wParam, LPARAM lParam )
{
    if ((unsigned) m_nAiboID != HIWORD(wParam)) {
        // This is not my AIBO that I requested to connect to
        return S_FALSE;
    }
    if (lParam) {
        // External control
        buttonRemote().EnableWindow(FALSE);
        buttonAutonomy().EnableWindow(TRUE);
		m_bControl = TRUE;

		// Start Face Detective
		m_pVAibo->SetRobotObjectMode(eRobotObjectDetectiveFace, eRobotObjectModeStart);
		// Start Target Recogniton
		m_pVAibo->SetRobotObjectMode(eRobotObjectRecognizeObjectPink, eRobotObjectModeStart);
		// Start Moveving Object Recogniton
		m_pVAibo->SetRobotObjectMode(eRobotObjectRecognizeMObject, eRobotObjectModeStart);
		// Start VPR Recogniton
		m_pVAibo->SetRobotObjectMode(eRobotObjectRecognizeVisualPattern, eRobotObjectModeStart);
    } else {
        // Internal control
        buttonRemote().EnableWindow(TRUE);
        buttonAutonomy().EnableWindow(FALSE);
        m_bControl = FALSE;
    }

    return S_OK;
}

void CMindScopeDlg::OnBtnConnect()
{
    if ( !m_bConnected ) {
        UpdateData();

        BYTE        nField0, nField1, nField2, nField3;
        m_ipAddress.GetAddress(nField0, nField1, nField2, nField3 );
        theApp.m_sAiboIP.Format("%d.%d.%d.%d", nField0, nField1, nField2, nField3 );
        buttonConnect().SetWindowText( "Connecting..." );
        m_myRequest = TRUE;
		int nAiboID;
        nAiboID = m_pVAibo->Connect((LPCTSTR)theApp.m_sAiboIP);
        if (nAiboID < 0) {
            CString msgerr;
            msgerr.Format("AIBO connection error (%d), see VAIBODef.h", nAiboID);
            AfxMessageBox(msgerr);
        } else {
			m_nAiboID = nAiboID;
		}
    } else {
        buttonConnect().SetWindowText( "Disconnecting..." );
        m_myRequest = TRUE;
        int result = m_pVAibo->Disconnect();
        if (result != VAIBO_NOERROR) {
            CString msgerr;
            msgerr.Format("AIBO disconnection error (%d), see VAIBODef.h", result);
            AfxMessageBox(msgerr);
        }
    }
}


void CMindScopeDlg::OnBtnRemote()
{
    if ( m_pVAibo != NULL ) {
        if (!m_bControl) {
            // Check another application getting remote control
            if ( m_pVAibo->IsRemote() ) {
                OnVAIBORemoteNotify(((unsigned)m_nAiboID)<<16, 1);
            } else 
            // Start controlling from PC
            if ( !(m_pVAibo->ExternalControl(FALSE)) ) {
                CString msgerr;
                msgerr.Format("ExternalControl error");
                AfxMessageBox(msgerr);
            }
        }
    }
}

void CMindScopeDlg::OnBtnAutonomy()
{
    if ( m_pVAibo != NULL ) {
        if (m_bControl) {
            // Check another application releasing remote control
            if ( !(m_pVAibo->IsRemote()) ) {
                OnVAIBORemoteNotify(((unsigned)m_nAiboID)<<16, 0);
            } else 
            // Stop controlling from PC
            if ( !(m_pVAibo->InternalControl(FALSE)) ) {
                CString msgerr;
                msgerr.Format("InternalControl error");
                AfxMessageBox(msgerr);
            }
        }
    }
}

void CMindScopeDlg::OnDestroy()
{

    CDialog::OnDestroy();

    if ( m_pVAibo != NULL ) {
        if ( m_bConnected ) {
            int result = m_pVAibo->Disconnect();
            if (result != VAIBO_NOERROR) {
                CString msgerr;
                msgerr.Format("AIBO disconnection error (%d), see VAIBODef.h", result);
                AfxMessageBox(msgerr);
            }
        }
        delete m_pVAibo;
        m_pVAibo = NULL;
    }

	if ( m_imageBufN != NULL ) {
        free( m_imageBufN );
    }

}

void CMindScopeDlg::OnClose()
{
	CDialog::OnClose();
}

LRESULT CMindScopeDlg::OnITPImageUpdate( WPARAM wParam, LPARAM recvLen )
{
	ImageUpdate(wParam, recvLen);
    return S_OK;
}

void CMindScopeDlg::ImageUpdate(WPARAM wParam, LPARAM recvLen)
{
	unsigned char   *recvBuf = NULL;
    recvBuf = (unsigned char*)::calloc( 1, recvLen );

	// Get JPEG Data from shared memory
	m_pVAibo->ImageGetData( recvBuf, recvLen );
	JPEG2BMP( recvBuf, recvLen );

	if (recvBuf) {
        free(recvBuf);
    }

	long openrTime;
	int imageType;
	int size, num;
	unsigned char buff[500];
	BlockInfo bi;

	// Get Image Information from shared memory
	m_pVAibo->ImageGetInfo(&openrTime, &imageType, &num, &size);

	// Get Recogniton Data from shared memory
	m_pVAibo->ImageGetRecogData(&bi, buff, size );

	unsigned char *p = buff;

	m_bBlockDataEnable = FALSE;
	m_bPointDataEnable = FALSE;
	m_bPoint2DataEnable = FALSE;

	if( --m_point_4_count <= 0) {
		m_bPoint4DataEnable = FALSE;
	}
	for(int i=0; i< num ; i++) {
		RecogHeader *rh = (RecogHeader*)p;

		int rrID = rh->rrID;
		long rt = rh->openrTime;
		int secSize = rh->secSize;
		p += sizeof(RecogHeader);

		switch ( rrID ) {
		case rrUnkown:
			TRACE("rrUnkown\n");
			break;
		case rr1Point:
			{
			OnePoint* op = (OnePoint*)p;
			m_point_1.X = op->x;
			m_point_1.Y = op->y;
			memcpy(&m_recogHeader1,rh, sizeof(RecogHeader));;
			m_bPointDataEnable = TRUE;
			break;
			}
		case rr2Point:
			{
			TwoPoint* tp = (TwoPoint*)p;
			m_point_2[0].X = tp->x1;
			m_point_2[0].Y = tp->y1;
			m_point_2[1].X = tp->x2;
			m_point_2[1].Y = tp->y2;
			memcpy(&m_recogHeader2,rh, sizeof(RecogHeader));;
			m_bPoint2DataEnable = TRUE;
			break;
			}
		case rr4Point:
			{
			FourPoint* fp = (FourPoint*)p;
			m_point_4[0].X = fp->x1;
			m_point_4[0].Y = fp->y1;
			m_point_4[1].X = fp->x2;
			m_point_4[1].Y = fp->y2;
			m_point_4[2].X = fp->x3;
			m_point_4[2].Y = fp->y3;
			m_point_4[3].X = fp->x4;
			m_point_4[3].Y = fp->y4;
			memcpy(&m_recogHeader4,rh, sizeof(RecogHeader));;
			m_bPoint4DataEnable = TRUE;
			m_point_4_count = 5;
			break;
			}
		case rrBlockArea:
			{
			SetBlockData( p, bi);
			m_bBlockDataEnable = TRUE;
			break;
			}
		default:
			TRACE("Not define:%d num = %d i=%d\n", rrID, num, i );
		}
		p += secSize;
	}

	Invalidate(FALSE);

}

void CMindScopeDlg::JPEG2BMP(unsigned char *recvBuf, int len )
{

    JPEG_CORE_PROPERTIES    jpeg;
    int imageBufLen = 0;

    if ( m_imageBufN != NULL ) {
        free( m_imageBufN );
    }

    /*
        JPEG->BMPϊ(Intel̃Tv𗘗p)
    */
    IJLERR      jerr;
    int         imageLen, pad_bytes;

    memset( (void*)&jpeg, 0, sizeof(jpeg) );
    jerr = ijlInit( &jpeg );    // JPEG
    if ( jerr != IJL_OK ) {
        TRACE( "ijlInit::Error\r\n" );
        return;
    }
    jpeg.JPGFile = NULL;
    jpeg.JPGBytes = recvBuf;        // JPEGf[^AhX
    jpeg.JPGSizeBytes = len;    // JPEGf[^

    jerr = ijlRead( &jpeg, IJL_JBUFF_READPARAMS );
    if ( jerr != IJL_OK ) {
        TRACE( "ijlRead:Error(%d)\r\n", jerr );
        return;
    }

    if ( jpeg.JPGChannels == 1 ) {
        jpeg.JPGColor = IJL_G;
        jpeg.DIBColor = IJL_RGB;
        jpeg.DIBChannels = 3;
    } else if ( jpeg.JPGChannels == 3 ) {
        jpeg.DIBColor = IJL_BGR;
        jpeg.DIBChannels = 3;
    } else {
        jpeg.JPGColor = IJL_OTHER;
        jpeg.DIBColor = IJL_OTHER;
        jpeg.DIBChannels = jpeg.JPGChannels;
    }

    // C[Wp̈̌vZ
    jpeg.DIBWidth = jpeg.JPGWidth;
    jpeg.DIBHeight = -( abs( jpeg.JPGHeight ) );
    pad_bytes = IJL_DIB_PAD_BYTES( jpeg.DIBWidth, jpeg.DIBChannels );
    imageLen = jpeg.DIBWidth * jpeg.DIBChannels + pad_bytes;
    m_bmpLen = imageLen = imageLen * abs( jpeg.DIBHeight ) + sizeof(BITMAPINFO);
    m_imageBufN = (unsigned char*)malloc(imageLen);
    if ( m_imageBufN == NULL ) {
        TRACE("JpegConvert:malloc error\r\n");
        return;
    }
    imageBufLen = imageLen;

    // DIBvpeB̐ݒ
    unsigned char *buf = m_imageBufN + sizeof(BITMAPINFO);
    jpeg.DIBPadBytes = pad_bytes;
    jpeg.DIBBytes = buf;

    jerr = ijlRead(&jpeg,IJL_JBUFF_READWHOLEIMAGE); // BITMAPϊ
    if ( jerr != IJL_OK ) {
        TRACE("ijlRead() Error\r\n");
        return;
    }

    BITMAPINFO* bmi = (BITMAPINFO*)m_imageBufN;

    bmi->bmiHeader.biSize          = sizeof(BITMAPINFOHEADER);
    bmi->bmiHeader.biWidth         = jpeg.DIBWidth;
    bmi->bmiHeader.biHeight        = abs(jpeg.DIBHeight);
    bmi->bmiHeader.biCompression   = BI_RGB;
    bmi->bmiHeader.biBitCount      = 24;
    bmi->bmiHeader.biPlanes        = 1;
    bmi->bmiHeader.biClrUsed       = 0;
    bmi->bmiHeader.biClrImportant  = 0;
    bmi->bmiHeader.biSizeImage     = 0;
    bmi->bmiHeader.biXPelsPerMeter = 0;
    bmi->bmiHeader.biYPelsPerMeter = 0;
    bmi->bmiColors[0].rgbRed       = 0;
    bmi->bmiColors[0].rgbGreen     = 0;
    bmi->bmiColors[0].rgbBlue      = 0;
    bmi->bmiColors[0].rgbReserved  = 0;

    m_bitmapWidth = jpeg.DIBWidth;
    m_bitmapHeight = abs(jpeg.DIBHeight);

    ijlFree(&jpeg);

}

void CMindScopeDlg::SetBlockData(unsigned char *block, BlockInfo blockInfo)
{
	m_bBlockDataEnable = TRUE; 

	m_blockInfo = blockInfo;

	if ( m_pBlockData ) {
		memcpy( m_pBlockData, block, blockInfo.nBlock_DataSize);
	}
}
