// MindScopeDlg.h : Header file
//

#if !defined(AFX_MINDSCOPEDLG_H__0455D009_8F33_464D_BFD4_217E1E47A32F__INCLUDED_)
#define AFX_MINDSCOPEDLG_H__0455D009_8F33_464D_BFD4_217E1E47A32F__INCLUDED_

#include "VAIBO.h"
#include "VAIBODef.h"
#include <gdiplus.h>

using namespace Gdiplus;

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define BLOCK_DATA_MAX 512


/////////////////////////////////////////////////////////////////////////////
// CMindScopeDlg dialog

class CMindScopeDlg : public CDialog
{
// Construction
public:
	CMindScopeDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CMindScopeDlg)
	enum { IDD = IDD_MINDSCOPE_DIALOG };
	CIPAddressCtrl	m_ipAddress;

	//}}AFX_DATA

	//{{AFX_VIRTUAL(CMindScopeDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

//  Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CMindScopeDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnBtnAutonomy();
	afx_msg void OnBtnConnect();
	afx_msg void OnBtnRemote();
	afx_msg void OnDestroy();
	afx_msg void OnClose();
	//}}AFX_MSG
	afx_msg LRESULT OnVAIBOConnect( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnVAIBOConnectUpdate( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnVAIBODisconnect( WPARAM wParam, LPARAM lParam );
    afx_msg LRESULT OnVAIBOSemantics( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnVAIBORemoteNotify( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnVAIBOInputSemantics( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnITPImageUpdate( WPARAM wParam, LPARAM recvLen );
	afx_msg LRESULT OnVAIBOSensorData( WPARAM wParam, LPARAM recArray );
	DECLARE_MESSAGE_MAP()
public:
	CVAIBO *m_pVAibo;

protected:
	int m_nAiboID; 
	BOOL m_bConnected;
	BOOL m_bControl;
	BOOL m_myRequest;

	CButton& buttonConnect()  { return *(CButton*) GetDlgItem( IDC_BTN_CONNECT ); };
	CButton& buttonRemote()   { return *(CButton*) GetDlgItem( IDC_BTN_REMOTE ); };
	CButton& buttonAutonomy() { return *(CButton*) GetDlgItem( IDC_BTN_AUTONOMY ); };

	void ImageUpdate(WPARAM wParam, LPARAM recvLen);
	void SetBlockData( unsigned char* block, BlockInfo blockInfo);
	void JPEG2BMP( unsigned char *recvBuf, int len);

    unsigned char *m_imageBufN;
	int m_bmpLen;
    int m_bitmapWidth;
    int m_bitmapHeight;

	BlockInfo m_blockInfo;
	unsigned char m_pBlockData[BLOCK_DATA_MAX];
	BOOL m_bBlockDataEnable;

	Point m_point_1;
	BOOL m_bPointDataEnable;
	RecogHeader m_recogHeader1;

	Point m_point_2[2];
	BOOL m_bPoint2DataEnable;
	RecogHeader m_recogHeader2;

	Point m_point_4[4];
	BOOL m_bPoint4DataEnable;
	RecogHeader m_recogHeader4;
	int m_point_4_count;


};

//{{AFX_INSERT_LOCATION}}

#endif // !defined(AFX_MINDSCOPEDLG_H__0455D009_8F33_464D_BFD4_217E1E47A32F__INCLUDED_)
